package com.nisum.productreader.controller;

import com.nisum.productreader.model.Product;
import com.nisum.productreader.service.ProductKafkaProducer;
import com.nisum.productreader.service.ProductService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import reactor.core.publisher.Flux;
import reactor.util.Loggers;

@RestController
@RequestMapping("/products")
public class ProductController {

    private Logger logger = LoggerFactory.getLogger(ProductController.class);
    @Autowired
    private ProductService productService;

    @Autowired
    private ProductKafkaProducer kafkaProducer;

    @GetMapping("/getAllProducts")
    public Flux<Product> getAllProducts(){
        logger.info("Received request to get all products from CSV file.");
        Flux<Product> products = productService.readProductFromCsv();

        // Publish the products to Kafka topic
        kafkaProducer.publishProducts(products, "product-topic"); // Replace with your topic name

        return products;
    }
}
